﻿

namespace HoistingCrane
{
    public class EntityHoistingCrane
    {
        /// Скорость
        public int Speed { get; private set; }
        /// Вес
        public double Weight { get; private set; }
        /// Основной цвет
        public Color BodyColor { get; private set; }
        /// Дополнительный цвет (для опциональных элементов)
        public Color AdditionalColor { get; private set; }
        /// Признак (опция) наличия крана
        public bool Crane { get; private set; }
        /// Признак (опция) наличия противовеса
        public bool Counterweight { get; private set; }
        /// Шаг перемещения автомобиля
        public double Step => Speed * 100 / Weight;

        /// Инициализация полей объекта-класса спортивного автомобиля
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес автомобиля</param>
        /// <param name="bodyColor">Основной цвет</param>
        /// <param name="additionalColor">Дополнительный цвет</param>
        /// <param name="crane">Признак наличия крана</param>
        /// <param name="counterweight">Признак наличия противовеса</param>
        public void Init(int speed, double weight, Color bodyColor, Color
        additionalColor, bool crane, bool counterweight)
        {
            Speed = speed;
            Weight = weight;
            BodyColor = bodyColor;
            AdditionalColor = additionalColor;
            Crane = crane;
            Counterweight = counterweight;
        }

    }
}
