﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace HoistingCrane
{
    public partial class FormHoistingCrane : Form
    {
        private DrawingHoistingCrane? _drawingHoistingCrane;

        public FormHoistingCrane()
        {
            InitializeComponent();
        }
        /// Метод прорисовки машины
        private void Draw()
        {
            if (_drawingHoistingCrane == null)
            {
                return;
            }
            Bitmap bmp = new(pictureBoxHoistingCrane.Width,
            pictureBoxHoistingCrane.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawingHoistingCrane.DrawTransport(gr);
            pictureBoxHoistingCrane.Image = bmp;
        }

        /// Обработка нажатия кнопки "Создать"
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonCreate_Click(object sender, EventArgs e)
        {
            Random random = new();
            _drawingHoistingCrane = new DrawingHoistingCrane();
            _drawingHoistingCrane.Init(random.Next(100, 300), random.Next(1000, 3000),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)));
            _drawingHoistingCrane.SetPictureSize(pictureBoxHoistingCrane.Width, pictureBoxHoistingCrane.Height);
            _drawingHoistingCrane.SetPosition(random.Next(10, 100), random.Next(10, 100));
            Draw();
        }

        /// Перемещение объекта по форме (нажатие кнопок навигации)
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonMove_Click(object sender, EventArgs e)
        {
            if (_drawingHoistingCrane == null)
            {
                return;
            }
            string name = ((Button)sender)?.Name ?? string.Empty;
            bool result = false;
            switch (name)
            {
                case "buttonUp":
                    result =
                    _drawingHoistingCrane.MoveTransport(DirectionType.Up);
                    break;
                case "buttonDown":
                    result =
                    _drawingHoistingCrane.MoveTransport(DirectionType.Down);
                    break;
                case "buttonLeft":
                    result =
                    _drawingHoistingCrane.MoveTransport(DirectionType.Left);
                    break;
                case "buttonRight":
                    result =
                    _drawingHoistingCrane.MoveTransport(DirectionType.Right);
                    break;
            }
            if (result)
            {
                Draw();
            }
        }
    }
}
